

# 定义一个方法，用于将颜色值由纯黑色改为深灰色
def change_color(color)
  if color == Sketchup::Color.new(0, 0, 0) # 纯黑色
    gray_color = Sketchup::Color.new(80, 80, 80) # 深灰色
    return gray_color
  else
    return color
  end
end

# 定义一个方法，用于遍历当前模型中的所有材质并修改颜色
def modify_materials
  model = Sketchup.active_model  # 获取当前模型
  materials = model.materials  # 获取当前模型中的材质
  count = 0  # 计数器，统计需要修改的材质数量

  materials.each do |material|
    if material.color == Sketchup::Color.new(0, 0, 0) # 判断颜色是否为纯黑色
      material.color = change_color(material.color) # 修改颜色为深灰色
      count += 1
    end
  end

  return count # 返回需要修改的材质数量
end

# 定义一个方法，用于创建按钮并绑定事件处理
def create_button
	unless file_loaded?(__FILE__)
		UI.menu("Plugins").add_item("修改纯黑材质"){
    count = modify_materials
    message = "当前有 #{count} 个纯黑材质可以被修改, 确定开始运算吗?"
    result = UI.messagebox(message, MB_OKCANCEL) # 提示用户确认是否进行修改
    if result == IDOK
      modify_materials
      UI.messagebox("全部纯黑材质已经成功被替换")
    end
  }
		file_loaded(__FILE__)
path = Sketchup.find_support_file("Plugins/chage-black-to-glay")
  toolbar = UI::Toolbar.new("修改纯黑材质")
  cmd = UI::Command.new("修改纯黑材质") {
    count = modify_materials

      modify_materials
      UI.messagebox("#{count}个纯黑材质已经成功被替换")

  }
  cmd.small_icon = File.join(path,"icon_16.png")
  cmd.large_icon = File.join(path,"icon_24.png")
  cmd.tooltip = "修改纯黑材质"
  cmd.status_bar_text = "将场景中全部纯黑材质修改为深灰色"
  toolbar = toolbar.add_item cmd
  toolbar.show
    end
end
# 调用方法创建按钮
create_button
